#include <cmath>
#include <iostream>   
#include "evn.hpp"
#include "groupea.hpp"
#include "em.hpp"

using namespace std;


bool evn::certifie(evn* e1, evn* e2, evn* e3, double l1, double l2){
   bool resem=false, resev=false;
   ev * g1, * g2, * g3, *g4;
   em * em1, *em2, * em3, * em4;

   em1 = e1;
   em2 = e2;
   em3 = e3;
   em4 = this;
   resem = em4->certifie(em1,em2,em3);
   g1 = e1;
   g2 = e2;
   g3 = e3;
   g4 = this;
   resev = g4->certifie(g1,g2,g3,l1,l2);
   if(resem+resev==2) {cout<<" c'est un evn "<<endl; return true;}
   else {return false;}
}

bool ev::certifie(ev* p1, ev* p2, ev* p3, double l1, double l2){
  bool resgroupe=false, resloc=false, resev=false;
  int c=0;
  double l3=0.0;
  groupea * g1, * g2, * g3, * g4;

   g1 = p1;
   g2 = p2;
   g3 = p3;
   g4 = this;

  resgroupe = g4->certifie(g1,g2,g3);

  this->zero();
  
  p3-> addition(p1,this); // p3 =p1
  p1->addition(p1,p2); // p1 = p1+p2
  p1->produit_externe(l1); //p1 = l1 * (p1+p2)
  p2->produit_externe(l1); // p2 = l1 p2
  p3->produit_externe(l1); //p3 = l1 p1
  p2->addition(p2,p3); // p2 = l1 p1 + l2 p2
  resloc =p1->equal(p2); 
  c= c+ resloc;
  resloc=false;

 
  p2->addition(p1,this); // donc p2 = p1
  p3->addition(p1,this); // donc p3 = p1

  l3 = l1 + l2;
  p1->produit_externe(l3); // (l1 +l2) p1

  p2->produit_externe(l1); // p2 = l1 p1
  p3->produit_externe(l2); // p3 = l2 p1
  p2->addition(p2,p3); // P2 = l1 p1 + l2 p1
  resloc =p1->equal(p2);
  c= c+ resloc;
  resloc=false;
  

  l3 = l1*l2;
  p2->addition(p1,this); // donc p2 = p1
  p1->produit_externe(l3); // p1 = (l1 l2) p1
  p2->produit_externe(l2);  // p2 = l2 p1
  p2->produit_externe(l1); // p2 = l1 (l2 p1)
  resloc =p1->equal(p2); 
  c= c+ resloc;
  resloc=false;

  l1=p1->un();
  p2->addition(p1,this); // p2 =p1
  p1->produit_externe(l1);
  resloc =p1->equal(p2);
  c= c+ resloc;
  resloc=false;

  if(c==4) {resev=true; cout<<" c'est un ev "<<endl;}
  if(resev ==false) {cout<<" ce n'est pas un ev "<<endl; exit(0);}
 return resev;
}


double mat2::dis(em * e1, em * e2){
   double res;
   mat2 * p1 = dynamic_cast <mat2 *> (e1);
   mat2 * p2 = dynamic_cast <mat2 *> (e2);
   mat2 a(0.0,0.0,0.0,0.0);
   mat2 b(0.0,0.0,0.0,0.0);

   a.oppose(p2);
   b.addition(p1,&a);
   res = b.norm(&b);
   return res;
}


mat2 mat2::operator + (mat2 x){
  mat2 res;
   res.addition(this,&x);
   return res;
   cout<<"+ de mat2"<<endl;
}
mat2 mat2::operator - (mat2 x){
  mat2 res,op;
   op.oppose(&x);
   res.addition(this,&op);
   return res;
   cout<<"- de mat2"<<endl;
}

bool mat2::equal (groupea * x){
  bool res=false;
  double eps=0.0000000000001;
  int c = 0;
  mat2 * p = dynamic_cast <mat2 *> (x);

  if(abs(mat[0][0] -p->mat[0][0]) <eps) {res=true;};
  c = c + res;
   if(abs(mat[0][1] -p->mat[0][1]) <eps) {res=true;};
  c = c + res;
  if(abs(mat[1][0] -p->mat[1][0]) <eps) {res=true;};
  c = c + res;
  if(abs(mat[1][1] -p->mat[1][1]) <eps) {res=true;};
  c = c + res;	

  res = false;
  if (c==4) {res= true;}
   return res;
}

mat2 & mat2::operator = (const mat2 & x){
   mat[0][0]=x.mat[0][0];	
   mat[0][1]=x.mat[0][1];
   mat[1][0]=x.mat[1][0];
   mat[1][1]=x.mat[1][1];
   return *this;
   cout<<"= du sous groupe"<<endl;
}

void mat2::oppose(groupea * x){
    mat2 * p = dynamic_cast <mat2 *> (x);	
    mat[0][0] =-p->mat[0][0];	
    mat[0][1] =-p->mat[0][1];
    mat[1][0] =-p->mat[1][0];
    mat[1][1] =-p->mat[1][1];
    cout<< "oppose mat2 "<<endl;
}

void mat2::zero(){
    mat[0][0] = 0.0;	
    mat[1][0] = 0.0;
    mat[0][1] = 0.0;
    mat[1][1] = 0.0;
    cout<<" zero du mat2"<<endl;
}

void mat2::addition (groupea * x1, groupea *x2){
   mat2 * p1 = dynamic_cast <mat2 *> (x1);
   mat2 * p2 = dynamic_cast <mat2 *> (x2);
  
   mat[0][0]= p1->mat[0][0] + p2->mat[0][0];	
   mat[0][1]= p1->mat[0][1] + p2->mat[0][1];
   mat[1][0]= p1->mat[1][0] + p2->mat[1][0];
   mat[1][1]= p1->mat[1][1] + p2->mat[1][1];
   cout<<"addition de mat2"<<endl;
  
}

void mat2::produit_externe(double x){
   mat[0][0]= x*mat[0][0];	
   mat[0][1]= x*mat[0][1];
   mat[1][0]= x*mat[1][0];
   mat[1][1]= x*mat[1][1];
   cout<<" produit externe de mat 2"<<endl;
}
double mat2::un(){
   double res=1.0;
   return res;
}

double mat2::norm(evn * e1){
    double res=0.0,l1=0.0,l2=0.0;
    mat2 * p1 = dynamic_cast <mat2 *> (e1);

    l1 = abs(p1->mat[0][0])+abs(p1->mat[0][1]);
    l2 = abs(p1->mat[1][0])+abs(p1->mat[1][1]);
    res= max(l1,l2);
    return res;
}

ostream & operator <<(ostream & out, const mat2 & x){
   out<<" A = {"<<x.mat[0][0]<<", "<<x.mat[0][1]<<", "<<x.mat[1][0]<<", "<<x.mat[1][1]<<" }"<<endl;
   return out;
}
