#ifndef EVN_HPP

#include <cmath>
#include <iostream>
#include "em.hpp"
#include "groupea.hpp"

using namespace std;

class ev : public groupea {
public:

  virtual void oppose(groupea *)=0;
  virtual void addition(groupea *, groupea *)=0;
  virtual bool equal (groupea *)=0;
  virtual void zero(){} ;
  virtual void produit_externe(double)=0;
  virtual double un()=0;
  bool certifie(ev*, ev*, ev*, double, double);
};

class evn : public ev, public em {
public:
  
  virtual void oppose(groupea *)=0;
  virtual void addition(groupea *, groupea *)=0;
  virtual bool equal (groupea *)=0;
  virtual void zero()=0;
  //void zero(){};
  virtual void produit_externe(double)=0;
  virtual double un()=0;
  virtual double norm(evn*)=0;
  double dis(em *,em *);
  bool certifie(evn*, evn*, evn*, double, double);
};



class mat2 : public evn {
protected:
 double mat[2][2];
public:
  mat2 (){};
  mat2 (double a11, double a12, double a21, double a22){
    mat[0][0]=a11;  mat[0][1]=a12;
    mat[1][0]=a21;  mat[1][1]=a22;
  }
  mat2 (const mat2 & x){
    mat[0][0]=x.mat[0][0];  mat[0][1]=x.mat[0][1];
    mat[1][0]=x.mat[1][0];  mat[1][1]=x.mat[1][1];
  }
  ~mat2 (){};

mat2 operator +(mat2);
mat2 operator -(mat2);
mat2 & operator =(const mat2 &);
void oppose(groupea *);
void addition(groupea *, groupea *);
bool equal (groupea *);
void zero();
void produit_externe(double);
double un();
double norm(evn *);
double dis(em *, em *);
friend ostream & operator << (ostream &,const mat2 &);
};

#endif
